/**
	$Id $

	Copyright (C) 2012 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.util.json;


/**
	Implementations should convert a given object to an object that 
	can be serialized into a JSON string. 
	
	@author nicklas
	@since 3.3
*/
public interface JsonConverter<T>
{

	/**
		Convert the given object to a JSON-compatible object.
		The parameter may be null.
		
		@param object The objcet to convert
	*/
	public Object convert(T object);
	
}
