<%-- $Id: create_child_bioplate_step2.jsp 6611 2014-11-20 13:53:55Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2011 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.BioPlate"
	import="net.sf.basedb.core.BioPlateEvent"
	import="net.sf.basedb.core.BioPlateEventType"
	import="net.sf.basedb.core.BioPlateType"
	import="net.sf.basedb.core.PlateGeometry"
	import="net.sf.basedb.core.MeasuredBioMaterial"
	import="net.sf.basedb.core.Hardware"
	import="net.sf.basedb.core.Protocol"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.formatter.FormatterSettings"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="java.util.List"
	import="java.util.Date"
	import="java.util.Collections"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final int sourcePlateId = Values.getInt(request.getParameter("sourceplate_id"));
final int numChildPlates = Values.getInt(request.getParameter("number_of_plates"), 1);
final int childPlateTypeId = Values.getInt(request.getParameter("bioplatetype_id"));
final int childPlateGeometryId = Values.getInt(request.getParameter("plategeometry_id"));
final String childPlateNamePrefix = Values.getString(request.getParameter("plate_name_prefix"), "New plate.");

final ItemContext cc = sc.getCurrentContext(Item.BIOPLATEEVENT, BioPlateEventType.CREATE_BIOMATERIAL);
final DbControl dc = sc.newDbControl();
try
{
	final BioPlate sourcePlate = BioPlate.getById(dc, sourcePlateId);
	final Item childBioMaterialType = Item.valueOf(request.getParameter("child_biomaterial_type"));
	final boolean isBioAssayEvent = childBioMaterialType == Item.PHYSICALBIOASSAY;

	final PlateGeometry geometry = isBioAssayEvent ? null : PlateGeometry.getById(dc, childPlateGeometryId);
	final int size = Values.getInt(request.getParameter("size"));
	final BioPlateType sourceType = sourcePlate.getBioPlateType();
	final Item sourceBioMaterialType = sourceType.getBioMaterialType();
	
	final Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	final String dateFormat = FormatterSettings.getDateFormat(sc);
	final String jsDateFormat = HTML.javaScriptEncode(dateFormat);
	final String htmlDateFormat = HTML.encodeTags(dateFormat);
	final boolean showSourceCoordinates = Values.getBoolean(sc.getUserClientSetting("create-child-plate.show-source-coordinates"), true);
	%>
	<base:page type="popup" title="Create child bioplate - step 2/2" id="step-2">
	<base:head scripts="plate.js,js-draw.js,~create_child_bioplate.js" styles="plate.css,toolbar.css" />
	<base:body>
		<div id="canvas" style="position: absolute; z-index: 99;"></div>
		
		<h1>Create child bioplate - step 2/2 <base:help helpid="bioplateevent.create-child-2" /></h1>
		<form name="main" action="index.jsp" method="post">
		<input type="hidden" name="ID" value="<%=ID%>">
		<input type="hidden" name="cmd" value="CreateChildPlate">
		<input type="hidden" name="sourceplate_id" value="<%=sourcePlateId%>">
		<input type="hidden" name="source_biomaterial_type" value="<%=sourceBioMaterialType.name()%>">
		<!-- event properties -->
		<input type="hidden" name="event_name" value="<%=HTML.encodeTags(request.getParameter("event_name"))%>">
		<input type="hidden" name="event_description" value="<%=HTML.encodeTags(request.getParameter("event_description"))%>">
		<input type="hidden" name="event_date" value="<%=HTML.encodeTags(request.getParameter("event_date"))%>">
		<input type="hidden" name="protocol_id" value="<%=Values.getInt(request.getParameter("protocol_id"))%>">
		<input type="hidden" name="hardware_id" value="<%=Values.getInt(request.getParameter("hardware_id"))%>">
		<!-- child plate properties -->
		<input type="hidden" name="number_of_plates" value="<%=numChildPlates%>">
		<input type="hidden" name="size" value="<%=size%>">
		<input type="hidden" name="rows" value="<%=geometry == null ? 1 : geometry.getRows()%>">
		<input type="hidden" name="columns" value="<%=geometry == null ? size : geometry.getColumns()%>">
		<input type="hidden" name="childplate_prefix" value="<%=HTML.encodeTags(childPlateNamePrefix)%>">
		<input type="hidden" name="plategeometry_id" value="<%=childPlateGeometryId%>">
		<input type="hidden" name="bioplatetype_id" value="<%=childPlateTypeId%>">
		<input type="hidden" name="freezer_id" value="<%=Values.getInt(request.getParameter("freezer_id"))%>">
		<input type="hidden" name="plate_description" value="<%=HTML.encodeTags(request.getParameter("plate_description"))%>">
		<!-- child biomaterial properties -->
		<input type="hidden" name="child_biomaterial_type" value="<%=childBioMaterialType.name()%>"> 
		<input type="hidden" name="subtype_id" value="<%=request.getParameter(childBioMaterialType.name() + "_subtype_id")%>">
		<input type="hidden" name="original_quantity" value="<%=HTML.encodeTags(request.getParameter("original_quantity"))%>">
		<input type="hidden" name="used_quantity" value="<%=HTML.encodeTags(request.getParameter("used_quantity"))%>">
		<input type="hidden" name="child_description" value="<%=HTML.encodeTags(request.getParameter("child_description"))%>">
		<input type="hidden" name="tag_id" value="<%=HTML.encodeTags(request.getParameter("tag_id"))%>">
		
		<div class="content">
			<div class="absolutefull bg-filled-50" style="height: 1.8em;">
				<tbl:toolbar id="toolbar.mappings" subclass="bottomborder" style="height: 100%;">
					<tbl:button 
						id="btnClearMapping"
						title="Clear" 
						image="cancel.png" 
						tooltip="Clear all mapped wells"
					/>
					<tbl:button 
						id="btnPlaceByRow"
						title="Place by row" 
						image="place_by_row.png" 
						tooltip="Place remaining items; start with rows"
					/>
					<tbl:button 
						id="btnPlaceByColumn"
						title="Place by column" 
						image="place_by_column.png" 
						tooltip="Place remaining items; start with columns"
					/>
					<tbl:button 
						id="btnSelectPlateMapping"
						title="Predefined mapping&hellip;" 
						image="star.png" 
						tooltip="Select a predefined plate mapping"
					/>
				</tbl:toolbar>
			</div>
	
			<div class="absolutefull bottomborder" style="top: 1.8em;">
	
				<div class="absolutefull" style="width: 50%;">
					<div class="absolutefull bg-filled-100" style="height: 2em;">
						<div class="padded">
						<b>Source plate:</b> <span id="plate.src.name"></span>
						</div>
					</div>
					
					<div class="absolutefull topborder rightborder" style="top: 2em; bottom: 10em;">
						<table style="margin: auto;"><tr><td>
							<div id="plate.src" style="margin-top: 1em;"></div>
						</td></tr></table>
					</div>
					
					<div class="absolutefull rightborder" style="top: auto; height: 10em;" >
					<table class="fullform input100 smaller topborder" id="childplate.info" style="display: none;">
						<tbody class="sectionheader">
							<tr>
								<th colspan="2"><%=isBioAssayEvent ? "Physical bioassay" : "Child plate"%></th>
							</tr>
						</tbody>
						<tbody>
							<tr>
								<th>Name</th>
								<td><input class="text required" type="text" name="plate_name" value="" 
									maxlength="<%=BioPlate.MAX_NAME_LENGTH%>"></td>
							</tr>
							<%
							if (!isBioAssayEvent)
							{
								%>
								<tr>
									<th>Barcode</th>
									<td><input class="text" type="text" name="plate_barcode" value="" 
										maxlength="<%=BioPlate.MAX_BARCODE_LENGTH%>"></td>
								</tr>
								<%
							}
							%>
						</tbody>
						<tr class="dynamic">
							<th></th>
							<td></td>
						</tr>
					</table>
					</div>
				</div>
	
				<div class="absolutefull" style="left: auto; width: 50%;">
					<div class="absolutefull bg-filled-100" style="height: 2em;">
						<div class="padded">
							<b><%=isBioAssayEvent ? 
								"Physical bioassay(s)" : "Destination plate(s):"%></b> 
								<span id="plate.dest.info"><i>not created</i></span>
						</div>
					</div>
						
					<div class="absolutefull topborder" style="top: 2em;">
						<table style="margin: auto;"><tr><td>
							<div id="plate.dest" style="margin-top: 1em;"></div>
							<div id="plate.dest.options" style="display: none;">
								<input type="checkbox" name="showSourceCoordinates" id="showSourceCoordinates"
									<%=showSourceCoordinates ? "checked" : ""%> value="1"><label for="showSourceCoordinates">Show source coordinates</label>
							</div>
						</td></tr></table>
					</div>
					

					<div class="absolutefull" style="top: auto; height: 10em;">
					<table class="fullform input100 smaller topborder" id="childbiomaterial.info" style="display: none;">
						<tbody class="sectionheader">
							<tr>
								<th colspan="2">Child biomaterial</th>
							</tr>
						</tbody>
						<tbody>
							<tr>
								<th>Name</th>
								<td><input class="text required" type="text" name="biomaterial_name" value="" 
									maxlength="<%=MeasuredBioMaterial.MAX_NAME_LENGTH%>"></td>
							</tr>
						</tbody>
						<tr class="dynamic">
							<th></th>
							<td></td>
						</tr>
					</table>
					</div>
				</div>
			</div>

		</div>
		</form>

		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnSave" title="Save" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>
		
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>