/* $Id $
	------------------------------------------------------------------
	Copyright (C) 2012 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
*/



var Filters = function()
{
	var filters = {};
	
	filters.initPage = function()
	{
		// Save + Close buttons
		Buttons.addClickHandler('btnOk', Filters.reset);
		Buttons.addClickHandler('close', App.closeWindow);

		// Item type
		Events.addEventHandler('itemType', 'change', Filters.itemTypeOnChange);
	}
	
	/**
		Callback function that check/uncheck the 'in-database' option
		depedning on the selected item type.
	 */
	filters.itemTypeOnChange = function()
	{
		var frm = document.forms['filters'];
		var dbOnly = frm.item_type[frm.item_type.selectedIndex].text.indexOf('*') >= 0;
		frm.database.checked = dbOnly;
	}
	
	/**
		Reset the selected filter settings.
	 */
	filters.reset = function()
	{
		var frm = document.forms['filters'];
		frm.submit();
	}
	
	return filters;
}();

Doc.onLoad(Filters.initPage);