<%-- $Id: external_plugin_parameters.jsp 6982 2015-10-19 07:16:45Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2010 Martin Svensson
	
	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Martin
	@version 2.15
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.ParameterType"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.PluginConfiguration"
	import="net.sf.basedb.core.PluginConfigurationRequest"
	import="net.sf.basedb.core.PluginParameter"	
	import="net.sf.basedb.core.RequestInformation"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.StringParameterType"
	import="net.sf.basedb.util.error.ThrowableUtil"	
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.clients.web.util.HTML"	
	import="net.sf.basedb.plugins.executor.ExternalProgramExecutor"
	import="net.sf.basedb.plugins.executor.ParameterDefinition"
	import="net.sf.basedb.util.Values"	
	import="net.sf.basedb.util.json.JsonConverter"
	import="net.sf.basedb.util.json.JsonUtil"
	import="java.util.ArrayList"
	import="java.util.Arrays"
	import="java.util.Collections"
	import="java.util.HashMap"
	import="java.util.Iterator"
	import="java.util.List"
	import="java.util.Map"
	import="org.json.simple.JSONArray"
	import="org.json.simple.JSONObject"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%
	final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);



DbControl dc = null;
try
{
	PluginDefinition plugin = (PluginDefinition)sc.getSessionSetting("plugin.configure.plugin");	
	PluginConfiguration pluginConfig = (PluginConfiguration)sc.getSessionSetting("plugin.configure.config");
	PluginConfigurationRequest pcRequest = (PluginConfigurationRequest)sc.getSessionSetting("plugin.configure.request");
	RequestInformation ri = pcRequest.getRequestInformation();
	String title = HTML.encodeTags(ri.getTitle());
	String helpText = ri.getDescription();	
	if (helpText == null && config != null) helpText = pluginConfig.getDescription();
	if (helpText == null) helpText = plugin.getDescription();

	String errorMessage = (String)sc.getSessionSetting("plugin.configure.errors.message");
	List<Throwable> errors = (List<Throwable>)sc.getSessionSetting("plugin.configure.errors.list");
	
	String xml = request.getParameter("parameter:externalParameters");
	if (xml == null) xml = (String)pcRequest.getCurrentParameterValue("externalParameters");
	List<ParameterDefinition> externalParameters = null;
	JSONArray jsonParameters = null;
	try
	{
		externalParameters = ParameterDefinition.parseXml(xml, false);
		jsonParameters = JsonUtil.toArray(externalParameters, new JsonConverter<ParameterDefinition>()
			{
				public Object convert(ParameterDefinition def)
				{
					JSONObject json = new JSONObject();
					json.put("parameterType", def.getType());
					json.put("name", def.getName());
					json.put("required", def.isRequired() ? 1 : 0);
					json.put("multiple", def.isMultiple() ? 1 : 0);
					json.put("defaultValue", def.getDefaultValue());
					json.put("description", def.getDescription());
					JSONObject jsonOptions = new JSONObject();
					for (String option : def.getOptions())
					{
						jsonOptions.put(option, def.getOption(option));
					}
					json.put("options", jsonOptions);
					return json;
				}
			});

	}
	catch (Throwable ex)
	{
		errorMessage = "Could not load parameter definitions";
		errors = Collections.singletonList(ex);
	}
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="xml.js,/plugins/net/sf/basedb/plugins/executor/external_plugin_parameters.js" styles="parameters.css,toolbar.css" />
	<base:body>
		<h1><%=title%> <base:help helpid="executor.program.parameters" /></h1>

		<div id="page-data" class="datacontainer"
			data-parameters="<%=HTML.encodeTags(jsonParameters.toJSONString()) %>"
		></div>

		<form action="index.jsp" method="post" name="configure">
		<input type="hidden" name="ID" value="<%=ID%>">
		<input type="hidden" name="cmd" value="SetParameters">
		<input type="hidden" name="requestId" value="<%=request.getParameter("requestId")%>">
		<input type="hidden" name="parameter:externalParameters" value="">
		
		<div class="content">
		
			<div class="absolutefull bg-filled-100" style="height: 4.5em;">
				<table style="height: 100%; margin:auto;"><tr><td style="padding: 3px;">
				<b>
					<%=plugin == null ? "" : HTML.encodeTags(plugin.getName())%>
					<%=pluginConfig == null ? "" : "(" + HTML.encodeTags(pluginConfig.getName()) + ")"%>
				</b><br>
				<%=HTML.niceFormat(helpText)%>
				</td></tr></table>
			</div>
		
			<div class="absolutefull topborder bottomborder" style="top: 4.5em;">
			<div class="absolutefull" style="width: 18em;">

					<tbl:toolbar subclass="bottomborder bg-filled-50">
						<tbl:button 
							id="btnAddParameter"
							image="add.png" 
							title="Add" 
							tooltip="Add a new parameter definition"
						/>
						<tbl:button 
							id="btnRemoveParameter"
							image="remove.png" 
							title="Remove" 
							tooltip="Remove the selected parameter(s)"
						/>
						<tbl:button 
							id="btnMoveUp"
							data-move-down="0"
							image="move_up.png" 
							tooltip="Move the selected paramer(s) up"
						/>
						<tbl:button 
							id="btnMoveDown"
							data-move-down="1"
							image="move_down.png" 
							tooltip="Move the selected paramer(s) down"
						/>
					</tbl:toolbar>
					
					<select name="programParameters" id="programParameters" size="20" style="width: 99%;"></select>
			</div>
			
			<div class="absolutefull leftborder" style="left: 18em;">
				<table id="parameterDefinition" class="fullform input100" style="xdisplay: none;">
				<%
				if (errorMessage != null || (errors != null && errors.size() > 0))
				{
					%>
					<tr>
						<td colspan="2">
						<div id="errors">
							<div class="messagecontainer error">
							<%=errorMessage %>
							<%
							if (errors != null && errors.size() > 0)
							{
								%>
								<div id="showerrorlist">
									<base:icon 
										id="btnShowError"
										image="gonext.png" 
										style="color: #FFFFFF;"
										tooltip="Show more information about each error"
									/>
								</div>
								<div id="errorlist" style="display: none; margin: 0px;">
									<base:icon 
										id="btnHideError"
										image="move_down.png" 
										style="color: #FFFFFF;" 
										tooltip="Show less information"
									/>
								<ol>
								<%
								int i = 0;
								for (Throwable t : errors)
								{
									++i;
									%>
									<li><%=t.getMessage()%>
										<base:icon
											subclass="auto-init"
											data-auto-init="toggle-stacktrace"
											data-stracktrace-index="<%=i%>"
											image="gonext.png" 
											tooltip="Toggle display of detailed stacktrace"
											id="<%="stacktracelink." + i %>"
										/>
										<div id="stacktrace.<%=i%>" class="stacktrace" 
											style="display:none; height: 15em;"><%=ThrowableUtil.stackTraceToString(t)%></div>
										<%
									}
									%>
								</ol>
								</div>
								<%
							}
							%>
							</div>
						</div>
						</td>
					</tr>
					<%
				}
				%>
				<tr>
					<th>Name</th>
					<td><input type="text" class="text required" name="parameterName" id="parameterName"></td>
				</tr>
				<tr>
					<th>Parameter type</th>
					<td>
						<select name="parameterType" id="parameterType" size="1" class="required">
							<option value="string" 
								title="A free-text string no more than 255 characters"
								>String (short)</option>
							<option value="text"
								title="A free-text string up to 64K characters"
								>String (long)</option>
							<option value="integer"
								title="An integer that is optionally bounded"
								>Integer</option>
							<option value="float"
								title="A floating point number"
								>Float</option>
							<option value="boolean"
								title="A true/false selection"
								>Boolean</option>
							<option value="enumeration"
								title="Select value(s) from a predefined list"
								>Enumeration</option>
							<option value="factor"
								title="Select experimental factor(s) to include in the export"
								>Experimental factor</option>
							<option value="spotformula"
								title="Select a spot formula to include in the export"
								>Spot field/formula</option>
							<option value="assays"
								title="Select special assays (all are still included in the export)"
								>Bioassay selection</option>
						</select>
						<br>
						<input type="checkbox" name="parameterIsRequired" id="parameterIsRequired" value="1">
						<label for="parameterIsRequired">Required</label>
						<input type="checkbox" name="parameterIsMultiple" id="parameterIsMultiple" value="1">
						<label for="parameterIsMultiple">Multiple values</label>
					</td>
				</tr>
				<tr id="minMax" style="display:none;">
					<th>Min</th>
					<td>
						<input type="text" class="text" name="minValue" id="minValue" style="width:8em;">
						<b>Max</b>
						<input type="text" class="text" name="maxValue" id="maxValue" style="width:8em;">
					</td>
				</tr>
				<tr id="enumerationOptions" style="display:none;">
					<th>Options</th>
					<td>
						<textarea name="enumerationOptions" id="enumerationOptions" rows="5"
							title="One option per line"></textarea>
					</td>
				</tr>
				<tr id="regularDefault">
					<th>Default value</th>
					<td><input type="text" class="text" name="parameterDefault" id="parameterDefault"
						title="Enter a default values for the parameter"></td>
				</tr>
				<tr id="booleanDefault" style="display:none;">
					<th>Default value</th>
					<td><input type="radio" name="booleanDefault" id="booleanDefaultTrue" value="1" 
							><label for="booleanDefaultTrue">true</label>
						<input type="radio" name="booleanDefault" id="booleanDefaultFalse" value="0" 
							><label for="booleanDefaultFalse">false</label>
					</td>
				</tr>
				<tr class="dynamic">
					<th>Description</th>
					<td><textarea name="parameterDescription" id="parameterDescription" rows="5"  
						title="Enter a description/help text for this parameter"></textarea></td>
				</tr>
				</table>
				
			</div>
				
			</div>
			
		</div>
		</form>

		<base:buttongroup subclass="dialogbuttons">			
			<base:button id="btnSave" title="Next" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null)
		dc.close();
}
%>
