/* $Id $
	------------------------------------------------------------------
	Copyright (C) 2013 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
*/

var CloneReporters = function()
{
	var cloneReporters = {};
	
	/**
		Initialize the page.
	*/
	cloneReporters.initPage = function()
	{
		// Save + Close buttons
		Buttons.addClickHandler('btnSave', cloneReporters.save);
		Buttons.addClickHandler('close', App.closeWindow);

		// Template
		Buttons.addClickHandler('reporterclonetemplate_id.select', cloneReporters.selectTemplate);
		Events.addEventHandler('reporterclonetemplate_id', 'base-selected', cloneReporters.setTemplateCallback);
	}
	
	
	cloneReporters.validateClone = function()
	{
		var frm = document.forms['clone'];
		
		if (frm.reporterclonetemplate_id.selectedIndex < 0)
		{
			Forms.showNotification('reporterclonetemplate_id.select', 'A template must be selected');
			return false;
		}

		return true;
	}
	
	// Submit the form
	cloneReporters.save = function()
	{
		var frm = document.forms['clone'];
		if (cloneReporters.validateClone())
		{
			frm.submit();
		}
	}

	cloneReporters.selectTemplate = function()
	{
		var frm = document.forms['clone'];
		var url = '';
		if (frm.reporterclonetemplate_id.length > 1) 
		{
			var id = Math.abs(parseInt(frm.reporterclonetemplate_id[1].value));				
			url += '&item_id='+id;
		}
		Dialogs.selectItem('REPORTERCLONETEMPLATE', 'reporterclonetemplate_id', 0, url);
	}
	
	cloneReporters.setTemplateCallback = function(event)
	{
		var frm = document.forms['clone'];
		var list = frm.reporterclonetemplate_id;
		if (list.length < 2 || list[1].value == '0')
		{
			Forms.addListOption(list, 1, new Option());
		}
		list[1].value = event.detail.id;
		list[1].text = event.detail.name;
		list.selectedIndex = 1;
	}


	
	return cloneReporters;
}();

Doc.onLoad(CloneReporters.initPage);

